{known_script id="jquery.ui" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.core.packed.js"}
{known_script id="jquery.ui.dialog" src=$ROOT_URL|@cat:"themes/default/js/ui/packed/ui.dialog.packed.js"}

{literal}
<style type='text/css'>
</style>

<script type="text/javascript">
/**
 * include this template in a page and use dialogChooseASERateBox.show({options}) to display
 * the dialog box
 *
 */
dialogChooseASERateBox = function()
{
  var dialogOptions = {
      id:'',
      eventOk:null,
      cBuilder:null,

      values: {
        minValue:'',
        maxValue:'',
        searchType:'no'
      },
    };

  /**
   * initialize the dialog box
   */
  var initDialogBox = function()
  {
    $("#iDialogASERateChoose")
    .dialog(
      {
        autoOpen: false,
        resizable: false,
        width:500,
        height:180,
        modal: true,
        draggable:true,
        dialogClass: 'gcBgTabSheet gcBorder',
        title: '{/literal}{"ase_choose_rate"|@translate}{literal}',
        open: function(event, ui)
        {
        },
        buttons:
        {
          '{/literal}{"ase_ok"|@translate}{literal}':
            function()
            {
              if(checkValidity())
              {
                dialogOptions.values.minValue=$('#iASERateMinValue').val();
                dialogOptions.values.maxValue=$('#iASERateMaxValue').val();
                dialogOptions.values.searchType=$('#iASERateSearchType').val();

                switch(dialogOptions.values.searchType)
                {
                  case 'gt':
                  case 'eq':
                    dialogOptions.values.maxValue='';
                    break;
                  case 'lt':
                    dialogOptions.values.minValue='';
                    break;
                }

                if(dialogOptions.cBuilder!=null)
                {
                  setCBuilderItem(dialogOptions.id, dialogOptions.values);
                }

                if(dialogOptions.eventOk!=null)
                {
                  dialogOptions.eventOk(dialogOptions.id, dialogOptions.values);
                }
                $(this).dialog('close');
              }
            },
          '{/literal}{"ase_cancel"|@translate}{literal}':
            function()
            {
              $(this).dialog('close');
            }
        }
      }
    );

    $('#iASERateSearchType').bind('change', changeSearchType);
  }


  /**
   * called when the search type is changed
   */
  var changeSearchType = function ()
  {
    switch($('#iASERateSearchType').val())
    {
      case 'no':
        $("#iASERateMinValueRow").hide();
        $("#iASERateMaxValueRow").hide();
        break;
      case 'bt':
        $("#iASERateMinValueRow").show();
        $("#iASERateMaxValueRow").show();
        break;
      case 'gt':
      case 'eq':
        $("#iASERateMinValueRow").show();
        $("#iASERateMaxValueRow").hide();
        break;
      case 'lt':
        $("#iASERateMinValueRow").hide();
        $("#iASERateMaxValueRow").show();
        break;
    }
  };


  var isDate = function (s)
  {
    re=/\d{2,4}-\d\d-\d\d/i;
    return((re.exec(s)!=null));
  }

  /**
   * check the validity of the condition
   * return Boolean : true if OK, otherwise false
   */
  var checkValidity = function ()
  {
    $(".error").removeClass('error');
    returned=true;

    if($('#iASERateSearchType').val()=='bt')
    {
      if($("#iASERateMinValue").val() > $("#iASERateMaxValue").val())
      {
        $("#iASERateMinValue, #iASERateMaxValue").addClass('error');
        returned=false;
        alert("{/literal}{'ase_error_rate_range'|@translate}{literal}");
      }
    }

    return(returned);
  }


  /**
   * the show() function display and manage a dialog box to choose categories
   * and the kind of test to apply
   *
   * @param options : properties to manage the dialog box
   *                  - id : a string to identify a DOM object ; this parameter
   *                         is given to the callback when the OK button is pushed
   *                  - values : an object with 3 properties
   *                               - dateType : 'c' for creation or 'a' for available
   *                               - from :
   *                               - to :
   *                  - eventOK : a callback function, with 2 parameters : id of
   *                              the given DOM object and values parameted
   *                  - cBuilder : a criteriaBuilder object
   *                               if set, the dialog box manage automaticaly
   *                               the criteria builder interface
   */
  this.show = function (options)
  {
    showDialog(options);
  }

  /**
   * private function used to show the dialog box
   */
  var showDialog = function(options)
  {
    if(options.id!=null)
    {
      dialogOptions.id=options.id;
    }
    else
    {
      dialogOptions.id='';
    }

    if(options.eventOk!=null)
    {
      dialogOptions.eventOk=options.eventOk;
    }

    if(options.cBuilder!=null)
    {
      dialogOptions.cBuilder=options.cBuilder;
      dialogOptions.cBuilder.doAction('setOptions',
        {
          onEdit:function (e) { editCB(e.data); },
          onDelete:function (e) { deleteCB(e.data); },
        }
      );
    }

    if(options.values!=null)
    {
      dialogOptions.values=jQuery.extend(dialogOptions.values, options.values);
    }
    else
    {
      dialogOptions.values.maxValue='5';
      dialogOptions.values.minValue='0';
      dialogOptions.values.searchType='no';
    }

    $('#iASERateMinValue').val(dialogOptions.values.minValue);
    $('#iASERateMaxValue').val(dialogOptions.values.maxValue);
    $('#iASERateSearchType').val(dialogOptions.values.searchType);

    changeSearchType();

    $("#iDialogASERateChoose").dialog('open');
  }



  /**
   * manage the 'edit' button from criteria builder interface
   * @param String itemId : the itemId
   */
  var editCB = function (itemId)
  {
    extraData=dialogOptions.cBuilder.doAction('getExtraData', itemId);
    showDialog(
      {
        id:itemId,
        values:
          {
            maxValue:extraData.param.maxValue,
            minValue:extraData.param.minValue,
            searchType:extraData.param.searchType
          },
      }
    );
  }

  /**
   * manage the 'delete' button from criteria builder interface
   * @param String itemId : the itemId
   */
  var deleteCB = function (itemId)
  {
    dialogOptions.cBuilder.doAction('delete', itemId);
  }

  /**
   * set the content for the cBuilder item
   */
  var setCBuilderItem = function(id)
  {
    var content="<div>{/literal}{'ase_the_rate'|@translate}{literal} ";

    switch(dialogOptions.values.searchType)
    {
      case 'no':
        content="<div>{/literal}{'ase_Dont_have_rate'|@translate}{literal} ";
        break;
      case 'eq':
        content+="{/literal}{'ase_is_equal2'|@translate}{literal} <span style='font-style:italic;'>"+dialogOptions.values.minValue+"</span>";
        break;
      case 'bt':
        content+="{/literal}{'ase_is_between2'|@translate}{literal} <span style='font-style:italic;'>"+dialogOptions.values.minValue+"</span> {/literal}{'ase_is_between_and2'|@translate}{literal} <span style='font-style:italic;'>"+dialogOptions.values.maxValue+"</span>";
        break;
      case 'gt':
        content+="{/literal}{'ase_is_greater_or_equal2'|@translate}{literal} <span style='font-style:italic;'>"+dialogOptions.values.minValue+"</span>";
        break;
      case 'lt':
        content+="{/literal}{'ase_is_less_or_equal2'|@translate}{literal} <span style='font-style:italic;'>"+dialogOptions.values.maxValue+"</span>";
        break;
    }

    content+="</div>";


    if(id=='')
    {
      //no id:add a new item in the list
      dialogOptions.cBuilder.doAction(
        'add',
        content,
        criteriaBuilder.makeExtendedData(
          'ASERate',
          {
            searchType:dialogOptions.values.searchType,
            minValue:dialogOptions.values.minValue,
            maxValue:dialogOptions.values.maxValue
          }
        )
      );
    }
    else
    {
      // update item
      dialogOptions.cBuilder.doAction(
        'edit',
        id,
        content,
        criteriaBuilder.makeExtendedData(
          'ASERate',
          {
            searchType:dialogOptions.values.searchType,
            minValue:dialogOptions.values.minValue,
            maxValue:dialogOptions.values.maxValue
          }
        )
      );
    }
  }

  initDialogBox();
}


</script>
{/literal}

<div id="iDialogASERateChoose" style='display:none;'>

  <table class="formtable">

    <tr>
      <td>{'ase_the_rate'|@translate}</td>
      <td>
        <select id="iASERateSearchType">
          <option value="no">{'ase_dont_have_rate'|@translate}</option>
          <option value="eq">{'ase_is_equal2'|@translate} ...</option>
          <option value="bt">{'ase_is_between2'|@translate} ... {'ase_is_between_and2'|@translate} ...</option>
          <option value="gt">{'ase_is_greater_or_equal2'|@translate} ... </option>
          <option value="lt">{'ase_is_less_or_equal2'|@translate} ... </option>
        </select>
      </td>
    </tr>


    <tr id="iASERateMinValueRow">
      <td>&nbsp;</td>
      <td>
        <select id="iASERateMinValue">
          <option value="0">0</option>
          <option value="1">1</option>
          <option value="2">2</option>
          <option value="3">3</option>
          <option value="4">4</option>
          <option value="5">5</option>
        </select>
      </td>
    </tr>

    <tr id="iASERateMaxValueRow">
      <td>&nbsp;</td>
      <td>
        <select id="iASERateMaxValue">
          <option value="0">0</option>
          <option value="1">1</option>
          <option value="2">2</option>
          <option value="3">3</option>
          <option value="4">4</option>
          <option value="5">5</option>
        </select>
      </td>
    </tr>


  </table>

</div>


